<template>
  <div id="dashboard">
    <header class="dashboard-header">
      <h1 class="dashboard-title">My Servers</h1>
    </header>

    <div class="server-list" v-if="servers.length">
      <template v-for="(server, index) in servers">
        <tippy
          :theme="`server-${server.status}`"
          trigger="click"
          maxWidth="none"
          arrow>
          <template #trigger>
            <ServerCard
                :index="index"
                :server="server">
            </ServerCard>
          </template>
          <ServerTooltip
              :index="index"
              :server="server">
          </ServerTooltip>
        </tippy>
      </template>
    </div>
    <div v-else>
      Loading... I think?
    </div>
  </div>
</template>

<script lang="ts">
import './scss/style.scss';

import { mapState } from 'vuex';
import { Component, Vue } from 'vue-property-decorator';
import ServerTooltip from './components/ServerTooltip.vue';
import ServerCard from './components/ServerCard.vue';

@Component({
  components: {
    ServerTooltip,
    ServerCard,
  },
  computed: mapState(['servers']),
})
export default class App extends Vue {
  public created() {
    this.$store.dispatch('loadServers');
  }
}
</script>
